package pl.alx.najprostszyopengl;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;
import java.nio.ShortBuffer;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import android.opengl.GLSurfaceView.Renderer;
import android.opengl.GLU;

public class RendererZPerspektywa implements Renderer {
	FloatBuffer kwadratWierzcholki;
	{
		ByteBuffer bb = ByteBuffer.allocateDirect(4 * 3 * 4); // cztery punkty po trzy wsprzdne po cztery bajty
		bb.order(ByteOrder.nativeOrder()); 
		kwadratWierzcholki = bb.asFloatBuffer();
		kwadratWierzcholki.put(new float[] {
			-0.1f, 0.1f, -0.2f, // NW
			0.1f, 0.1f, -0.2f, // NE
			0.1f, -0.1f, -0.2f, // SE
			-0.1f, -0.1f, -0.2f // SW
		});
		kwadratWierzcholki.position(0);
	}
	ShortBuffer kwadratPolaczenia;
	{
		ByteBuffer bb = ByteBuffer.allocateDirect(2 * 3 * 2); // dwa trjkty po trzy punkty po dwa bajty
		bb.order(ByteOrder.nativeOrder()); 
		kwadratPolaczenia = bb.asShortBuffer();
		kwadratPolaczenia.put(new short[] {
			0, 3, 2, // trjkt dolny-lewy
			2, 1, 0 // trjkt grny-prawy
		});
		kwadratPolaczenia.position(0);
	}
	
	public void onSurfaceCreated(GL10 gl, EGLConfig arg1) {
		gl.glEnableClientState(GL10.GL_VERTEX_ARRAY);
		gl.glEnable(GL10.GL_DEPTH_TEST);
	}

	public void onSurfaceChanged(GL10 gl, int width, int height) {
		gl.glViewport(0, 0, width, height);
		gl.glMatrixMode(GL10.GL_PROJECTION);
		gl.glLoadIdentity();
		GLU.gluPerspective(gl, 120, (float) width / height, 0.1f, 20);
		gl.glMatrixMode(GL10.GL_MODELVIEW);
		gl.glLoadIdentity();
		GLU.gluLookAt(gl, 0, 0, 0, 0, 0, -1, 0, 1, 0);
//		GLU.gluLookAt(gl, 0, -0.5f, 0, 0, 1, -1, 0, 1, 0);
	}

	public void onDrawFrame(GL10 gl) {
		gl.glClearDepthf(1.0f);
		gl.glClear(GL10.GL_DEPTH_BUFFER_BIT);
		gl.glPushMatrix();
		gl.glColor4f(1, 0, 0, 1);
		gl.glVertexPointer(3, GL10.GL_FLOAT, 0, kwadratWierzcholki);
		gl.glDrawElements(
				GL10.GL_TRIANGLES,
				kwadratPolaczenia.capacity(),
				GL10.GL_UNSIGNED_SHORT,
				kwadratPolaczenia
		);
		
//		przesunicie wzdu osi Z
		gl.glTranslatef(-0.3f, -0.3f, -0.3f);
		gl.glColor4f(0, 0, 1, 1);
		gl.glDrawElements(
				GL10.GL_TRIANGLES,
				kwadratPolaczenia.capacity(),
				GL10.GL_UNSIGNED_SHORT,
				kwadratPolaczenia
		);
		
//		obrt
		gl.glTranslatef(-0.1f, 0.4f, -0.1f);
		gl.glTranslatef(-0.3f, -0.3f, -0.3f-0.2f);
		gl.glRotatef(45, 1, 0, 0);
		gl.glTranslatef(-(-0.3f), -(-0.3f), -(-0.3f)+0.2f);
		gl.glColor4f(0, 1, 0, 1);
		gl.glDrawElements(
				GL10.GL_TRIANGLES,
				kwadratPolaczenia.capacity(),
				GL10.GL_UNSIGNED_SHORT,
				kwadratPolaczenia
		);

		gl.glPopMatrix();
	}
}

